<?php
//
//   CF Image Hosting Script v1.2
//   -------------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.2
//   Date:      16-Apr-10
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost1.2/
//   Copyright (c) 2010 codefuture.co.uk
//
////////////////////////////////////////////////////////////////////////////////////

	include_once('inc/config.php');

	if($SET_HIDE_CONTACT){
		header('Location: index.php');
		exit();
	}

////////////////////////////////////////////////////////////////////////////////////

// CONFIG YOUR ERROR MESSAGES
define('ERROR_MESSAGE_NAME',			'(Name can\'t be blank)');
define('ERROR_MESSAGE_EMAIL', 			'(E-mail can\'t be blank)');
define('ERROR_MESSAGE_EMAIL_INVALID',	'(Email is invalid)');
define('ERROR_MESSAGE_COMMENT',			'(Your comment can\'t be blank)');
define('ERROR_MESSAGE_CAPTCHA',			'(Verification code can\'t be blank)');
define('ERROR_MESSAGE_CAPTCHA_INVALID',	'(Verification code is invalid)');
define('ERROR_MESSAGE_CAPTCHA_COOKIE',	'(No captcha cookie given. Make sure cookies are enabled.)');

$error = FALSE;
$send  = FALSE;

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

	$name    = input($_POST['name']);
	$email   = input($_POST['email']);
	$comment = input($_POST['comment']);
	$captcha = input($_POST['captcha']);

	if(empty($name)){
		$error_name = ERROR_MESSAGE_NAME;
		$error 		= TRUE;
	}

	if(empty($email)){
		$error_email = ERROR_MESSAGE_EMAIL;
		$error		 = TRUE;
	}elseif(!eregi('^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$', $email) ||
			preg_match("/(%0A|%0D|\n+|\r+)(content-type:|to:|cc:|bcc:)/i", $email) ||
			preg_match("/(%0A|%0D|\n+|\r+)/i", $email)){
		$error_email = ERROR_MESSAGE_EMAIL_INVALID;
		$error		 = TRUE;
	}

	if(empty($comment)){
		$error_comment	= ERROR_MESSAGE_COMMENT;
		$error			= TRUE;
	}

	if(empty($captcha)){
		$error_captcha	= ERROR_MESSAGE_CAPTCHA;
		$error			= TRUE;
	}elseif (isset($_COOKIE['Captcha']) ){
		list($Hash, $Time) = explode('.', $_COOKIE['Captcha']);
		if ( md5("OASDOIJQWOIJDASDOI".$_REQUEST['captcha'].$_SERVER['REMOTE_ADDR'].$Time) != $Hash ){
			$error_captcha = ERROR_MESSAGE_CAPTCHA_INVALID;
			$error = TRUE;
		}
	}else{
		$error_captcha = ERROR_MESSAGE_CAPTCHA_COOKIE;
		$error = TRUE;
	}

	if(!$error) {

		if(strtoupper(substr(PHP_OS, 0, 3) == 'WIN')) $ent = "\r\n";
		elseif(strtoupper(substr(PHP_OS, 0, 3) == 'MAC')) $ent = "\r";
		else $ent = "\n";

		$comment  = ' Name: '.$name.$ent.' E-mail: '.$email.$ent.' Comment: '.$ent.$comment;
		$boundary = '----=_NextPart_' . md5(rand());
		$headers  = 'From: ' . $name . '<' . $email . '>' . $ent;
		$headers .= 'X-Mailer: PHP/' . phpversion() . $ent;
		$headers .= 'MIME-Version: 1.0' . $ent;
		$headers .= 'Content-Type: multipart/mixed; boundary="' . $boundary . '"' . $ent . $ent;
		$message  = '--' . $boundary . $ent;
		$message .= 'Content-Type: text/plain; charset="utf-8"' . $ent;
		$message .= 'Content-Transfer-Encoding: base64' . $ent . $ent;
		$message .= chunk_split(base64_encode($comment));

		ini_set('sendmail_from', $email);
		mail($SET_CONTACT, 'Email from contact form on '.$SET_TITLE, strip_tags(html_entity_decode($message)), $headers);
		$send = TRUE;
	}
}

	$menu='contact';
	include_once('header.php');
	if($send){
?>
					<p class="teaser">Thank you <?=$_POST['name']; ?><br/>
					We have received your information and will try and answer your question or comments ASAP.<br/>
					All your details are treated in the strictest confidence and we do not share any information with any third parties.</p>
<? }else{ ?>
					<? if($error){ error_note('Invalid Form Input') ;}?>
					<p class="teaser">Please include a valid email so we can contact you should we need to.<br/>
					Any email addresses submitted via this site will not be distributed.</p>
					<div id="form">
						<form  method="post" action="contact.php">
						<div class="code_box">
							<label for="name">Your Name</label>
							<input name="name" type="text" id="name" class="text_input" size="24" <? if(!empty($name)){ ?> value="<?=$name ?>" <? } ?> class="text-input" />
							<? if(!empty($error_name)) { ?>
								<span class="error_message"><?=$error_name ?></span>
							<? } ?>
						</div>
						<div class="code_box">
							<label for="email">Email 
								<? if(!empty($error_email)) { ?>
									<span class="error_message"><?=$error_email ?></span>
								<? } ?>
							</label>
							<input name="email" type="text" id="email" class="text_input" size="24" <? if(!empty($email)){ ?> value="<?=$email ?>" <? } ?> class="text-input" /><br/>
						</div>
						<div class="code_box contact">
							<label for="comment">Your comment 
								<? if(!empty($error_comment)) { ?>
									<span class="error_message"><?=$error_comment ?></span>
								<? } ?>
							</label>
							<textarea name="comment" id="comment" rows="8" class="text_input long"><? if(!empty($comment)){ echo $comment; } ?></textarea>
						</div>
						<div class="code_box">
							<label for="captcha">Are you human? 
								<? if(!empty($error_captcha)) { ?>
									<span class="error_message"><?=$error_captcha ?></span>
								<? } ?>
							</label>
							<input name="captcha" type="text" id="captcha" size="24" class="text_input" />
						</div>
						<div class="button_cen"><img src="inc/captcha.php<?=($SET_THEME=='dark'?'?bg':'');?>" /></div>
							<input type="submit" class="button  button_cen" value="Send" />
						</form>
					</div>
<?
	}

	include_once('footer.php');

// MAKE PAGE END
////////////////////////////////////////////////////////////////////////////////////
?>