<?php
//
//   CF Image Hosting Script v1.2
//   -------------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.2
//   Date:      16-Apr-10
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost1.2/
//   Copyright (c) 2010 codefuture.co.uk
//
////////////////////////////////////////////////////////////////////////////////////

//debug
	error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
// Hide all error messages from the public
	//error_reporting(E_ALL^E_NOTICE);
	//ini_set('display_errors', 0);

//load settings
	$ADD_DB_SET			= "upload/data/settings.cdb";
	$settings			= loadfromfile($ADD_DB_SET);

// Upload directory 
	$DIR_IMAGE			= 'upload/images/';
	$DIR_THUMB_MID		= 'upload/thumbs/';
	$DIR_THUMB			= 'upload/smallthumbs/';
	$DIR_BW_RESET		= 'upload/data/';

// DB addresss
	$ADD_DB_IMG			= 'upload/data/imgdb.ihdb';
	$ADD_DB_COUNT		= 'upload/data/imgdbcount.ihdb';
	$ADD_DB_BAN			= 'upload/data/ban.ihdb';

// Make sure the install.php file is deleted for normal usage
	if (file_exists('install.php')){
		include_once('install.php');
		exit();
	}

//global settings
	$SET_PASSWORD		= $settings[0];
	$SET_USERNAME		= $settings[1];
	$SET_CONTACT		= $settings[2];
	$SET_SITEURL		= $settings[3];
	$SET_TITLE			= $settings[4];
	$SET_SLOGAN			= $settings[5];
	$SET_MAXSIZE		= $settings[6];
	$SET_IMG_ON_PAGE	= $settings[7];
	$SET_COPYRIGHT		= $settings[8];
	$SET_THEME			= $settings[9];
	$SET_SALTING		= $settings[10];
	$SET_MOD_REWRITE	= $settings[11];
	$SET_ADMIN_MENU		= $settings[12];
	 //new 1.2
	$SET_MAX_BANDWIDTH		= $settings[13];
	$SET_VERSION			= $settings[14];
	$SET_GOOGLE_ANALYTICS	= $settings[15];
	$SET_BANDWIDTH_RESET	= $settings[16];
	$SET_MAX_UPLOAD			= $settings[17];
	$SET_HIDE_SEARCH		= $settings[18];
	$SET_GOOGLE_ADS			= $settings[19];
	$SET_AUTO_DELETED		= $settings[20];
	$SET_AUTO_DELETED_TIME	= $settings[21];
	$SET_AUTO_DELETED_JUMP	= $settings[22];
	$SET_HIDE_CONTACT		= $settings[23];
	$SET_HIDE_TOS			= $settings[24];
	$SET_HIDE_GALLERY		= $settings[25];

//Small Thumb settins
	$THUMB_OPTION		= 'auto';//crop, auto, exact
	$THUMB_MAX_WIDTH	= 170;
	$THUMB_MAX_HEIGHT	= 170;
	$THUMB_SAVE_EXT		= 'png'; // jpg, png, gif
	$THUMB_QUALITY		= 75; //1-100

//Thumb settins
	$THUMB_MID_OPTION		= 'auto';//crop, auto, exact
	$THUMB_MID_MAX_WIDTH	= 350;
	$THUMB_MID_MAX_HEIGHT	= 350;
	$THUMB_MID_SAVE_EXT		= 'png'; // jpg, png, gif
	$THUMB_MID_QUALITY		= 75; //1-100 

// Image Formats
	$accepted			= array('png', 'jpg', 'jpeg', 'gif', 'bmp');
	$acceptedtyp		= array('image/png', 'image/x-png', 'image/pjpeg', 'image/jpg', 'image/jpeg', 'image/gif', 'image/bmp');
	$types				= implode(", ",$accepted);


//other global var
	$Err='';
	$Suc='';

// AD Color setings
	$GOOGLE_ADS_BG = ($SET_THEME=='dark'?'191919':($SET_THEME=='light'?'EEEEEE':'F5F5F5'));
	$GOOGLE_ADS_BO = $GOOGLE_ADS_BG;
/*
google_color_border = "<?=$GOOGLE_ADS_BO;?>";
google_color_bg = "<?$GOOGLE_ADS_BG;?>";
google_color_link = "FFFFFF";
google_color_text = "FFFFFF";
google_color_url = "FFFFFF";
*/

/////////////////////////////////////////////////////////////////////////////////////////////
//auto run

// see if we need to reset bandwidth
if($SET_MAX_BANDWIDTH !=0){
	if(!file_exists($DIR_BW_RESET.date($SET_BANDWIDTH_RESET))){
		if(bandwidth_reset()){
			if(savetofile(array(),$DIR_BW_RESET.date($SET_BANDWIDTH_RESET))){
				if(file_exists($DIR_BW_RESET.(date($SET_BANDWIDTH_RESET)-1))){
					unlink ($DIR_BW_RESET.(date($SET_BANDWIDTH_RESET)-1));
				}
			}
		}
	}
}

//run auto delete
	autoDeleted();


////////////////////////////////////////////////////////////////////////////////////
// functions
////////////////////////////////////////////////////////////////////////////////////

function hotlink($ref=''){
	global $SET_SITEURL;
	$referrer = $ref !='' ? $ref:getenv( "HTTP_REFERER" );
	$ref_address	= explode('/',str_replace('www.', '', str_replace('http://', '',$referrer)));
	$home_address	= explode('/',str_replace('www.', '', str_replace('http://', '',$SET_SITEURL)));
	if($ref_address[0] == $home_address[0])
		return false;
	return true;
}

function not_max_bandwidth($id){
	global $ADD_DB_COUNT,$SET_MAX_BANDWIDTH;
	if(!hotlink())return true;

	$db = loadfromfile($ADD_DB_COUNT);
	$img_var = array('size','thumbsize','sthumbsize');
	$img_size = get_image_value('id',$id,$img_var);

	if (empty($db))return true; 

	foreach ($db as $k => $v){
		if ($v['id'] == $id){
			if (($SET_MAX_BANDWIDTH*1048576) > $v['bandwidth'])
				return true;
			else{
				header('Content-type: image/png');
				readfile('img/bandwidth.png');
				exit();
			}
		}
	}
	return true; 
}

function bandwidth_reset($id=null){
	global $ADD_DB_COUNT;
	$db = loadfromfile($ADD_DB_COUNT);
	$done = 0;
	if(empty($db))return true;
	foreach ($db as $k => $v){
		if($id == null || $id == $v['id']){
			$db[$k]['bandwidth'] = 0;
			$done = 1;
			break;
		}
	}
	if($done == 1)
		if (savetofile($db,$ADD_DB_COUNT))
			return true;
	return false;
}


function is_bannad($ip) {
	global $ADD_DB_BAN;
	$db = loadfromfile($ADD_DB_BAN);
	if (!empty($db)){
		foreach ($db as $k => $v){
			if ($v['ip'] == $ip) return true; 
		}
	}
	return false;
}


function error_note($myproblem) {
	if($myproblem !='')
		echo '<div id="err" class="notification error"><div><b>An error occured:</b> '.$myproblem.'</div></div>';
}

function success_note($mysuccess) {
	if($mysuccess !='')
		echo '<div id="suc" class="notification success"><div><b>Successfull:</b> '.$mysuccess.'</div></div>';
}

function input($in){
	$in = trim($in);
	if (strlen($in) == 0)
		return;
	return htmlspecialchars(stripslashes($in));
}

function removeSymbols($string) {
	$symbols = array('/','\\','\'','"',',','.','<','>','?',';',':','[',']','{','}','|','=','+','-','_',')','(','*','&','^','%','$','#','@','!','~','`');
	for ($i = 0; $i < count($symbols); $i++) {
		$string = str_replace($symbols[$i],' ',$string);
	}
	return trim($string);
}

function bookmarking($document_url,$document_title){
	$social_sites = array(
		"Digg"				=> "http://digg.com/submit?phase=2&url={url}&title={title}",
		"del.icio.us"		=> "http://del.icio.us/post?url={url}&title={title}",
		"Google Bookmarks"	=> "http://www.google.com/bookmarks/mark?op=edit&bkmk={url}&title={title}",
		"Windows Live"		=> "https://favorites.live.com/quickadd.aspx?url={url}&title={title}",
		"Facebook"			=> "http://www.facebook.com/sharer.php?u={url}&t={title}",
		"StumbleUpon"		=> "http://www.stumbleupon.com/submit?url={url}&title={title}",
		"Twitter"			=> "http://twitter.com/home?status={title} - {url}",
		"Google buzz"		=> "http://www.google.com/reader/link?url={url}&title={title}",
		);

	krsort($social_sites);
	$text = '<div class="bookmarking">';

// write all the social bookmarking links to the page
	foreach($social_sites as $social_site=>$social_url){

	// strip special chars to make a valid icon filename
		$social_icon = strtolower(preg_replace('/[^a-zA-Z0-9]/', '', $social_site));

	// replace vars {title} and {url} in $social_url
		$url = str_replace("{title}",urlencode($document_title),str_replace('{url}',urlencode($document_url),$social_url));

		$text .= ' <a href="'.$url.'" title="Submit to '.$social_site.'" rel="nofollow"><img src="img/'.$social_icon.'.png" alt="Submit to '.$social_site.'" /></a>';
	}
	$text .= '</div>';
	return $text;
}

function savetofile($menu_array=array(),$fileaddress){
	if($fp = @fopen($fileaddress, 'w+')){
		fwrite($fp, serialize($menu_array));
		fclose($fp);
		return true;
	}else
		return false;
}

function loadfromfile($fileaddress){
	if (file_exists($fileaddress ))
		$filearray = unserialize(file_get_contents($fileaddress)); 
	else
		$filearray = array();
	return $filearray;
}

function get_thumb_address($id,$linktype=""){
	global	$SET_SITEURL,
			$DIR_THUMB,
			$THUMB_SAVE_EXT,
			$SET_MOD_REWRITE;

	$fileaddress = $DIR_THUMB.$id.'.'.$THUMB_SAVE_EXT;

	if (file_exists($fileaddress)){
		if (!empty($linktype)){
			if($SET_MOD_REWRITE){
				return $SET_SITEURL.'/'.$linktype.'-'.$id.'.'.$THUMB_SAVE_EXT;
			}else{
				return $SET_SITEURL.'/?'.$linktype.'='.$id;
			}
		}
		elseif (empty($linktype))
			return $fileaddress;
	}
}

function get_thumb_mid_address($id,$linktype=""){
	global	$SET_SITEURL,
			$DIR_THUMB_MID,
			$THUMB_MID_SAVE_EXT,
			$SET_MOD_REWRITE;

	$fileaddress = $DIR_THUMB_MID.$id.'.'.$THUMB_MID_SAVE_EXT;

	if (file_exists($fileaddress)){
		if (!empty($linktype)){
			if($SET_MOD_REWRITE){
				return $SET_SITEURL.'/'.$linktype.'-'.$id.'.'.$THUMB_MID_SAVE_EXT;
			}else{
				return $SET_SITEURL.'/?'.$linktype.'='.$id;
			}
		}
		elseif (empty($linktype))
			return $fileaddress;
	}
	return false;
}

function get_image_address($id,$linktype='',$db_img=array()){
	global	$SET_SITEURL,
			$DIR_IMAGE,
			$ADD_DB_IMG,
			$SET_MOD_REWRITE;

	$ext = get_image_value('id',$id,'ext',$db_img);

	if (isset($ext)){
		$fileaddress = $DIR_IMAGE.$id.'.'.$ext;
		if (file_exists($fileaddress)){
			if (!empty($linktype)){
				if($SET_MOD_REWRITE){
					return $SET_SITEURL.'/'.$linktype.'-'.$id.'.'.$ext;
				}else{
					return $SET_SITEURL.'/?'.$linktype.'='.$id;
				}
			}
			elseif (empty($linktype))
				return $fileaddress;
		}
	}
	return false;
}

function get_image_value($typ,$id,$value,$db_img=array()){
	global $ADD_DB_IMG;

	$db = empty($db_img) ? loadfromfile($ADD_DB_IMG):$db_img;
	foreach ($db as $k => $v){
		if ($v[$typ] == $id){
			if (is_array($value)){
				foreach ($value as $vk){
					$ret[]=$v[$vk];
				}
				return $ret;
			}else
				return $v[$value];
		}
	}
}

function orderBy(&$data, $field, $order='$a,$b') {
	$code = "return strnatcmp(\$a['$field'], \$b['$field']);";
	@usort($data, create_function($order, $code));
}

function autoDeleted(){
	global	$ADD_DB_COUNT,
			$ADD_DB_IMG,
			$SET_AUTO_DELETED,
			$SET_AUTO_DELETED_TIME,
			$SET_AUTO_DELETED_JUMP,
			$DIR_BW_RESET;

	if(!$SET_AUTO_DELETED)return;

	if(file_exists($DIR_BW_RESET.'ad'.date($SET_AUTO_DELETED_JUMP)))return;

//load img counter
	$db_counter = loadfromfile($ADD_DB_COUNT);
//load img counter
	$db_img = loadfromfile($ADD_DB_IMG);

//find
	foreach ($db_img as $k => $v){
		$done = 0;
		if (!empty($db_counter)){
			foreach ($db_counter as $k_c => $v_c){
				if ($v_c['id'] == $v['id']){
					if( round(((time() - $v_c['date']) / 86400),2) >= $SET_AUTO_DELETED_TIME){
						$done = 1;
						$delete_id[] = array('id' => $v['id'], 'k' => $k);
					}
					break;
				}
			}
		}
		if($done == 0){
			if( round(((time() - $v['added']) / 86400),2) >= $SET_AUTO_DELETED_TIME)
				$delete_id[] = array('id' => $v['id'], 'k' => $k);
		}
	}

//delete images
//reload img db
	$db_img = loadfromfile($ADD_DB_IMG);
	if(!empty($delete_id)){
		foreach ($delete_id as $k => $v){
		//get image id
			$img_del_id = $v['id'];
		// Remove Image
			@unlink(get_image_address($img_del_id,'',$db_img));
		// Remove small thumb
			@unlink(get_thumb_address($img_del_id));
		// Remove thumb
			@unlink(get_thumb_mid_address($img_del_id));
		// Remove link from array
			unset($db_img[$v['k']]);
		}
		savetofile($db_img,$ADD_DB_IMG);
	}

	if(savetofile(array(),$DIR_BW_RESET.'ad'.date($SET_AUTO_DELETED_JUMP))){
		if(file_exists($DIR_BW_RESET.'ad'.(date($SET_AUTO_DELETED_JUMP)-1))){
			unlink ($DIR_BW_RESET.'ad'.(date($SET_AUTO_DELETED_JUMP)-1));
		}
	}
}

function countSave($img_id,$image_size){
	global $ADD_DB_COUNT;
	$db = loadfromfile($ADD_DB_COUNT);
	$i = 0;
	if (!empty($db)){
		foreach ($db as $k => $v){
			if ($v['id'] == $img_id){
				if ($image_size == 1) $db[$k]['date'] = time();
				$image_count = ($image_size == 1 ? 'image':($image_size == 2 ? 'thumb_mid':($image_size == 3 ? 'thumb':'gallery')));
				$db[$k][$image_count]++;

				if($image_size!=4){
					$image_count = ($image_size == 1 ? 'size':($image_size == 2 ? 'thumbsize':'sthumbsize'));
					$db[$k]['bandwidth'] += get_image_value('id',$img_id,$image_count);
				}

				$i= 1;
				break;
			}
		}
	}//empty
	if($i == 0){
		$image_bandwidth = get_image_value('id',$img_id,($image_size == 1 ? 'size':($image_size == 2 ? 'thumbsize':'sthumbsize')));
		$db[] = array(	'id'		=> $img_id,
						'date'		=> time(),
						'image'		=> ($image_size == 1 ? 1:0),
						'thumb_mid'	=> ($image_size == 2 ? 1:0),
						'thumb'		=> ($image_size == 3 ? 1:0),
						'gallery'	=> ($image_size == 4 ? 1:0),
						'bandwidth'	=> $image_bandwidth,
					);
	}
	if (savetofile($db,$ADD_DB_COUNT))
		return true;
}



function add_new_img($img_item_array=array(),$fileaddress){
	$img_array = loadfromfile($fileaddress);
	$img_array[] = $img_item_array;
	if (savetofile($img_array,$fileaddress))
		return true;
}

function format_size($size="",$file="") {
	if (empty($size) && !empty($file)) $size = @filesize($file);

	if (strlen($size) <= 9 && strlen($size) >= 7){
		$img_size = substr(number_format($size / 1048576,2), -2) == '00' 
					? number_format($size / 1048576,0):number_format($size / 1048576,2);
		$img_size .= " MB";
	}elseif (strlen($size) >= 10){
		$img_size = substr(number_format($size / 1073741824,2), -2) == '00' 
					? number_format($size / 1073741824,0):number_format($size / 1073741824,2);
		$img_size .= " GB";
	}else $img_size = number_format($size / 1024,0)." kb";

	return $img_size;
}

function checklogin() {
	if(isset($_SESSION['loggedin']))
		if ($_SESSION['loggedin'] == true)
			return true;
	return false;
}

function pagination($page_number,$items_on_page,$item_count,$page_name="",$ex_var=""){
	global $SET_MOD_REWRITE;

	$link_mod	= (!$SET_MOD_REWRITE ? '?p=':( $page_name =='' ? 'page':'?p='));
	$ex_var		= (!$SET_MOD_REWRITE ? $ex_var:( $page_name =='' ? '.html':$ex_var));

	$number_of_pages = ceil($item_count/$items_on_page);
	if (($number_of_pages*$items_on_page) < $item_count) $number_of_pages++;

	$pagination ='<div class="pagination">';
	$pagination .=($page_number>0 ? '<a href="'.$page_name.$link_mod.($page_number).$ex_var.'"><< Previous</a>':'<span class="disabled"><< Previous</span>');

	for ($i = 1; $i <= $number_of_pages; $i++) {
		if($i>($page_number-4) && $i<($page_number+5)){
			$pagination .=($i==$page_number+1 ? '<span class="current">'.$i.'</span>':'<a href="'.$page_name.$link_mod.$i.$ex_var.'">'.$i.'</a>');
		}else if($i<($page_number-3)){
			$pagination .='<a href="'.$page_name.$link_mod.'1'.$ex_var.'">1</a>...';
			$i=$page_number-3;
		}else if($i>($page_number+4)){
			if ($i !=($number_of_pages)) $pagination .='...';
			$pagination .='<a href="'.$page_name.$link_mod.($number_of_pages).$ex_var.'">'.($number_of_pages).'</a>';
			$i=$number_of_pages;
		}
	}

	$pagination .=($page_number<($number_of_pages-1) ? '<a href="'.$page_name.$link_mod.($page_number+2).$ex_var.'">Next >></a>':'<span class="disabled">Next >></span>');
	$pagination .='</div>';
	return $pagination;
}

////////////////////////////////////////////////////////////////////////////////////
// Start session
	session_name();
	if (!session_start()) {
		$Err ='Cannot start a new PHP session. Please contact server administrator or webmaster!';
	}
?>