<?php
//
//   CF Image Hosting Script v1.2
//   -------------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.2
//   Date:      16-Apr-10
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost1.2/
//   Copyright (c) 2010 codefuture.co.uk
//
////////////////////////////////////////////////////////////////////////////////////

	include_once('inc/config.php');

	if($SET_HIDE_SEARCH){
		header('Location: index.php');
		exit();
	}

////////////////////////////////////////////////////////////////////////////////////
// gallerie start

	// see what page we are on
		$page_number = (isset($_GET['p']) ? input($_GET['p'])-1:0);// 0=1st

	// load img db
		$db_img			= loadfromfile($ADD_DB_IMG);
		$db_img_count	= count($db_img);

//////////////////////////////////////////////////

	if( !empty ( $_GET['search'] ) ){
		$string = input($_GET['search']);
		$clean_string = new cleaner();
		$stemmed_string = $clean_string->parseString($string);

		if(!empty($stemmed_string)){

			$new_string = '';
			foreach ( array_unique ( split ( " ",$stemmed_string ) ) as $array => $value ){
				if(strlen($value) >= 3)
					$new_string .= ''.$value.' ';
			}
			$new_string = substr ( $new_string,0, ( strLen ( $new_string ) -1 ) );
			if ( strlen ( $new_string ) > 3 ){
				$split_stemmed = split ( " ",$new_string );
				foreach ($db_img as $k => $v) {
					foreach ($split_stemmed as $key => $val) {
						if( $val!='' && strlen ( $val ) > 0 ){
							if (array_search_bit($val,$db_img[$k],array('alt','name')))
								$found_img[]= $db_img[$k];
						}
					}//foreach
				}//foreach
			}else//strlen more them 3
				$Err .= 'Please enter at least 3 characters.';

			$db_img			= isset($found_img)?$found_img: array();
			$db_img_count	= count($db_img);

		}
	}else//search is not empty
		$Err .= 'you did not enter any think to search for';
///////////////////////////////////////////////////

	// count images in db to see if we need to make a page
		if($db_img_count > 0){

		// workout start - stop
			$img_star_on	= $page_number*$SET_IMG_ON_PAGE;
			$img_end_on		= (($img_star_on+$SET_IMG_ON_PAGE)>$db_img_count ? $db_img_count : $img_star_on+$SET_IMG_ON_PAGE);

		// page pagination
			$pagination		= pagination($page_number, $SET_IMG_ON_PAGE, $db_img_count);

		// order image db by new to old
			orderBy($db_img, 'added','$b,$a');

		// make gallery
			$img_gallery ='<ul class="gallery">';
			for ($i = $img_star_on; $i < $img_end_on; $i++) {

			// page var
				$thumb_mid_link	= get_thumb_mid_address($db_img[$i]['id'],"pm",$db_img); 
				$thumb_url		= get_thumb_address($db_img[$i]['id'],"dt",$db_img);

			//see if there is a alt(title) if not use the image name
				$alt_text = ($db_img[$i]['alt'] !="" ? $db_img[$i]['alt']:$db_img[$i]['name']);

			//image list for page
				$img_gallery .= '<li><a href="'.$thumb_mid_link.'" title="'.$alt_text.'" class="thumb" >
								<img src="'.$thumb_url.'" alt="'.$db_img[$i]['alt'].'"/>
								</a><h2><a href="'.$thumb_mid_link.'" title="'.$alt_text.'">'.$alt_text.'</a></h2></li>';

			}
			$img_gallery .= '</ul>'.$pagination;

		}//end db image count


// gallerie end
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
// MAKE PAGE END

	$menu = 'gallery';
	$page_title = $page_number == 0 ? ' - Image search for '.$string.' Page 1':' - Image Search for '.$string.' Page '.($page_number+1);
	include_once('header.php');
		echo error_note($Err);
		
		if (isset($img_gallery)){
			echo '<h4>Found <span class="search_for">'.$db_img_count.'</span> results for <span class="search_for">'.$string.'</span></h4>';
			echo $img_gallery;
		}else{
			echo '<h4>Sorry, No Results Found For <span class="search_for">'.$string.'</span></h4>';
			echo '<p>Suggestions:<br/>
					Make sure all words in your query are spelled correctly<br/>
					Try a shorter query, or replace some keywords</p>';
		}

	include_once('footer.php');

// MAKE PAGE END
////////////////////////////////////////////////////////////////////////////////////

function array_search_bit($search, $db, $searchIn=array()){
	foreach ($db as $k => $v){
		//echo strtolower($value)."<br/>";
		if (in_array(strtolower($k), $searchIn) || empty($searchIn)){
			if (strpos(strtolower($v), strtolower($search)) !== FALSE){
				//echo "<font color=red>".$k." => ".strtolower($v)."</font><br>";
				return true;
			}
		}
	}
	return false;
}

class Cleaner {

	var $stopwords = array(" find ", " about ", " me ", " ever ", " each ", " the ", " jpg ", " gif ", " png ", " bmp ");//you need to extend this big time.
	var $symbols = array('/','\\','\'','"',',','.','<','>','?',';',':','[',']','{','}','|','=','+','-','_',')','(','*','&','^','%','$','#','@','!','~','`'	);//this will remove punctuation

	function parseString($string) {
		$string = ' '.$string.' ';
		$string = $this->removeStopwords($string);
		$string = $this->removeSymbols($string);
		return $string;
	}
	
	function removeStopwords($string) {
		for ($i = 0; $i < sizeof($this->stopwords); $i++) {
			$string = str_replace($this->stopwords[$i],' ',$string);
		}

		return trim($string);
	}

	function removeSymbols($string) {
		for ($i = 0; $i < sizeof($this->symbols); $i++) {
			$string = str_replace($this->symbols[$i],' ',$string);
		}

		return trim($string);
	}
}


?>